﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace FinalProject
{
    //Hlavní střída
    public partial class Form1 : Form
    {
        private NactiNoty nacitac;
        private ZobrazNoty zobrazovac;
        private bool kreslime=false;
        public Form1()
        {
            InitializeComponent();
        }

        private void nacist_Click(object sender, EventArgs e)
        {

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Multiselect = false;
            ofd.Filter = "Textové soubory (*.txt)|*.txt";
            if (ofd.ShowDialog() == DialogResult.OK)
            {

                nacitac = new NactiNoty(ofd.FileName);
                zobrazovac = new ZobrazNoty(nacitac.poleNot);
                kreslime = true;
                Invalidate();
            }
            this.ClientSize = new Size(nacitac.poleNot.Length * 20 + 50, 300);
        }  
        protected override void  OnPaint(PaintEventArgs e)
        {
 	        base.OnPaint(e);
            Graphics gr = e.Graphics;
            if (kreslime)
            {
                zobrazovac.Zaklad(gr);
                zobrazovac.NakresliTakt(gr, nacitac.takt);
                Point ptN = new Point(0, 7);
                Point ptD = new Point(0, 35);
                double dobaTakt=0;
                for (int i = 0; i < nacitac.poleNot.Length; i++)
                {
                    dobaTakt += Convert.ToDouble(nacitac.poleNot[i].Delka);

                    if (nacitac.poleNot[i].Znak == "pomlka")
                        zobrazovac.NakresliPomlku(gr, Convert.ToDouble(nacitac.poleNot[i].Delka), i);
                    else
                        zobrazovac.NakresliNotu(gr, nacitac.poleNot[i].Znak, Convert.ToDouble(nacitac.poleNot[i].Delka), i);
                    if(dobaTakt+"/4" == nacitac.takt)
                    {
                        ptN.X = zobrazovac.zacatek + i * 18;
                       ptD.X = ptN.X;
                       gr.DrawLine(Pens.Black, ptN, ptD);
                       dobaTakt = 0;
                    }
                }
            }
        }

    }
    //Strktura reprezentující notu
    public struct Nota
    {
        public string Znak;
        public string Delka;
    }
    //třída načítající notu
    public class NactiNoty
    {
        public string takt="";
        public Nota[] poleNot;
        public NactiNoty(string path)
        {
            int pocetRadku = PocetRadku(path);
            StreamReader sr = new StreamReader(path);
            takt=sr.ReadLine();
            poleNot = new Nota[pocetRadku-1];
            string line="";
            for(int index=0; index<pocetRadku-1; index++)
            {
                line = sr.ReadLine();
                if (line != null)
                {
                    poleNot[index] = NactiNotu(line);
                }
                
            }
            

        }
        private int PocetRadku(string path)
        {
            StreamReader sr = new StreamReader(path);
            int pocet = 0;
            while (!sr.EndOfStream)
            {
                sr.ReadLine();
                pocet++;
            }
            sr.Close();
            return pocet;
        }
        private Nota NactiNotu(string line)
        {
            bool JeNota=true;
            Nota JednaNota=new Nota();
            for (int i = 0; i < line.Length; i++)
            {
                if ((line[i] == ' ') && JeNota)
                {
                    JeNota = false;
                    continue;
                }
                else if (JeNota)
                {
                    JednaNota.Znak += line[i];
                }
                else if (!JeNota)
                {
                    if (line[i] == '.')
                        JednaNota.Delka += ',';
                    else
                        JednaNota.Delka += line[i];

                }
            }
            return JednaNota;
        }

    }
    //třída zpbrazující notu
    public class ZobrazNoty
    {
        private int delka=0;
        private string pathBmp = @"c:\Z40\FinalProject\FinalProject\bmp\";
        private int sirkaKlice = 0;
        public int zacatek = 0;
        public ZobrazNoty(Nota[] poleNot)
        {
            delka = poleNot.Length * 20;
        }
        public void Zaklad(Graphics gr)
        {
            Point ptZ= new Point();
            Point ptK= new Point();
            ptZ.X=0;
            ptK.X=delka;
            Image klic = Image.FromFile(pathBmp+"klic.bmp");
            sirkaKlice=klic.Size.Width;
            for (int i = 1; i < 6; i++)
            {
                ptZ.Y = i * 7;
                ptK.Y = i * 7;
                gr.DrawLine(Pens.Black, ptZ, ptK);
            }
            gr.DrawImage(klic, new Point(0, 0));
            
        }
        public void NakresliTakt(Graphics gr, string takt)
        {
            Image znak=null;
            switch(takt)
            {
                case "3/4":
                    znak = Image.FromFile(pathBmp + "takt_3.bmp");
                    break;
                case "4/4":
                    znak = Image.FromFile(pathBmp + "takt_4.bmp");
                    break;
                case "5/4":
                    znak = Image.FromFile(pathBmp + "takt_5.bmp");
                    break;
            }
            gr.DrawImage(znak, new Point(sirkaKlice+10, 10));
            zacatek = sirkaKlice + 10 + znak.Width+10;
        }

        public void NakresliPomlku(Graphics gr, double delka,int pozice)
        {
            Image pomlka = null;
            if(delka==3)
                pomlka = Image.FromFile(pathBmp + "pomlka_" + 2 + ".bmp");
            else
                pomlka = Image.FromFile(pathBmp + "pomlka_" + (int)delka + ".bmp");
            gr.DrawImage(pomlka, new Point(zacatek+18 * pozice, (35-pomlka.Size.Height)/2));
            if (delka == 3 || (int)delka != delka)
                gr.FillEllipse(Brushes.Black, new Rectangle(new Point(zacatek + 18 * pozice+pomlka.Size.Width+2, (35-pomlka.Size.Height)/2), new Size(4, 4)));
                        
            
                
        }

        public void NakresliNotu(Graphics gr, string jmeno, double delka, int pozice)
        {
            string nozicka="dolu";
            double vyska = 0;
            Image nota = null;
            switch (jmeno)
            {
                    #region Nizke
                    case "C":                        
                    case "Cis":
                        vyska = 42;
                    break;
                    case "D":
                    case "Dis":
                        vyska = 38.5;
                        break;
                    case "E":
                        vyska = 35;
                        break;
                    case "F":
                    case "Fis":
                        vyska = 31.5;
                        break;
                    case "G":
                    case "Gis":
                        vyska = 28;
                        break;
                    case "A":
                    case "Ais":
                        vyska = 34.5;
                        break;
                    case "H":
                        vyska = 31;
                        break;
                    #endregion
                    #region vysoke
                    case "c":
                    case "cis":
                        vyska = 17.5;
                        break;
                    case "d":
                    case "dis":
                        vyska = 14;
                        break;
                    case "e":
                        vyska = 11.5;
                        break;
                    case "f":
                    case "fis":
                        vyska = 7;
                        break;
                    case "g":
                    case "gis":
                        vyska = 3.5;
                        break;
                    case "a":
                    case "ais":
                        vyska = 0;
                        break;
                    case "h":
                        vyska = -3.5;
                        break;
                    #endregion
            }
            switch (jmeno)
            {
                    #region Nizke
                    case "C":                        
                    case "Cis":
                    case "D":
                    case "Dis":
                    case "E":
                    case "F":   
                    case "Fis":
                    case "G":
                    case "Gis":
                    case "A":
                    case "Ais":
                    case "H":
                        nozicka = "nahoru";
                        break;
                    #endregion
                    
            }
            if((int)delka==3)
                nota = Image.FromFile(pathBmp + "nota_" + nozicka + "_" + 2 + ".bmp");
            else if((int) delka == 4)
                nota = Image.FromFile(pathBmp + "nota_" + 4 + ".bmp");
            else
                nota = Image.FromFile(pathBmp + "nota_" + nozicka + "_" + (int)delka+ ".bmp");
            if(nozicka=="nahoru")
                vyska = vyska - nota.Size.Height;

            gr.DrawImage(nota, new Point(zacatek + pozice * 18, (int)vyska));
        }
            
   }
        
}
